# Toloka Kit

[![GitHub Tests][github_tests_badge]][github_tests_link]

[github_tests_badge]: https://github.com/Toloka/toloka-kit/workflows/Tests/badge.svg?branch=main
[github_tests_link]: https://github.com/Toloka/toloka-kit/actions?query=workflow:Tests

[Website](https://toloka.ai) |
[Documentation](https://yandex.ru/dev/toloka/doc/concepts/about.html?lang=en)|
[Platform](http://toloka.yandex.com)


Designed by engineers for engineers, Toloka lets you integrate an on-demand workforce directly into your processes. Our cloud-based crowdsourcing platform is a fast and efficient way to collect and label large data sources for machine learning and other business purposes.

Main advantages of Toloka:
  - **Top-quality data** -  Collect and annotate training data that meets and exceeds industry quality standards thanks to multiple quality control methods and mechanisms available in Toloka.
  - **Scalable projects** - Have any amounts of image, text, speech, audio or video data collected and labeled for you by millions of skilled Toloka users across the globe.
  - **Cost-efficiency** - Save time and money with this purpose-built platform for handling large-scale data collection and annotation projects, on demand 24/7, at your own price and within your timeframe.
  - **Free, powerful API** - Build scalable and fully automated human-in-the-loop machine learning pipelines with a powerful open API.


Get Started and Documentation
--------------
Installing toloka-kit is as easy as `pip install toloka-kit`

Usage examples are available [here](https://github.com/Toloka/toloka-kit/tree/main/examples)

All Toloka documentation is available [here](https://yandex.com/dev/toloka/doc/concepts/about.html?lang=en).


Questions and bug reports
--------------
* For reporting bugs please use the [Toloka/bugreport](https://github.com/Toloka/toloka-kit/issues) page.
* Seek prompt advice at Russian-speaking [Telegram chat](https://t.me/tolokacommunity) (Abstract questions about the platform are also welcome)
* Seek prompt advice at English-speaking [Telegram chat](https://t.me/toloka_tech) (Mostly tech question)



License
-------
© YANDEX LLC, 2020-2021. Licensed under the Apache License, Version 2.0. See LICENSE file for more details.
